#ifndef Client_ServerRJ_H_
#define Client_ServerRJ_H_
#include "udf/DIDERO_PC.h"
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/Client_Server/Client_ServerRJ__Rep_Client_DivSQL.h"
#include "Atomic/Initializer/InitializerSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
extern short GV_debug_flag;
extern short GV_Number_of_Clients_and_Trans;
extern int GV_Efficient_Oper_Capacity_Server_1;
extern int GV_Efficient_Oper_Capacity_Server_2;
extern double GV_ExpScaling_LowerBound;

class Client_ServerRJ: public Join {
 public:
  Client_ServerRJ__Rep_Client_DivSQL * Rep_Client_DivSQL;
  InitializerSAN * Initializer;
  Place * Init_Blocking_Ptrs;
  Place * Number_of_Clients;
  Place * Start_Client_Servers;

  Client_ServerRJ();
  ~Client_ServerRJ();
};

#endif
