#ifndef Client_ServerRJ__Client_DivSQL_H_
#define Client_ServerRJ__Client_DivSQL_H_
#include "udf/DIDERO_PC.h"
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Atomic/TransactionSAN_2/TransactionSAN_2SAN.h"
#include "Atomic/ClientSAN/ClientSANSAN.h"
#include "Atomic/Middleware_SAN/Middleware_SANSAN.h"
#include "Atomic/TransactionSAN_1/TransactionSAN_1SAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
extern short GV_debug_flag;
extern short GV_Number_of_Clients_and_Trans;
extern int GV_Efficient_Oper_Capacity_Server_1;
extern int GV_Efficient_Oper_Capacity_Server_2;
extern double GV_ExpScaling_LowerBound;

class Client_ServerRJ__Client_DivSQL: public Join {
 public:
  TransactionSAN_2SAN * TransactionSAN_2;
  ClientSANSAN * ClientSAN;
  Middleware_SANSAN * Middleware_SAN;
  TransactionSAN_1SAN * TransactionSAN_1;
  Place * Begin_Edge_1;
  Place * Begin_Edge_2;
  Place * Begin_Success_1;
  Place * Begin_Success_2;
  Place * Client_ID;
  Place * Execute_Transaction_MW_Client;
  Place * Execute_Transaction_MW_Server_1;
  Place * Execute_Transaction_MW_Server_2;
  Place * Init_Blocking_Ptrs;
  Place * Mutex_granted;
  Place * Mutex_pool;
  Place * Number_of_Clients;
  Place * Oper_1;
  Place * Oper_2;
  Place * Operation_Executed_MW_Client;
  Place * Operation_Executed_MW_Server_1;
  Place * Operation_Executed_MW_Server_2;
  Place * ReacPulse_2_Server_1;
  Place * ReacPulse_2_Server_2;
  Place * Request_Operation_MW_Client;
  Place * Request_Operation_MW_Server_1;
  Place * Request_Operation_MW_Server_2;
  Place * Server_1_enabled;
  Place * Server_2_enabled;
  Place * Start_Client_Servers;

  Client_ServerRJ__Client_DivSQL();
  ~Client_ServerRJ__Client_DivSQL();
};

#endif
