#include "Durations_of_Requests_and_OperationsPVModel.h"

Durations_of_Requests_and_OperationsPVModel::Durations_of_Requests_and_OperationsPVModel(bool expandTimeArrays) {
  TheModel=new Client_ServerRJ();
  DefineName("Durations_of_Requests_and_OperationsPVModel");
  StateMode = 1;
  CreatePVList(3, expandTimeArrays);
  Initialize();
}



PerformanceVariableNode* Durations_of_Requests_and_OperationsPVModel::createPVNode(int pvindex, int timeindex) {
  switch(pvindex) {
  case 0:
    return new Durations_of_Requests_and_OperationsPV0(timeindex);
    break;
  case 1:
    return new Durations_of_Requests_and_OperationsPV1(timeindex);
    break;
  case 2:
    return new Durations_of_Requests_and_OperationsPV2(timeindex);
    break;
  }
  return NULL;
}
