#include "Durations_of_Requests_and_OperationsPVNodes.h"

Durations_of_Requests_and_OperationsPV0Impulse0::Durations_of_Requests_and_OperationsPV0Impulse0()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&ClientSAN);
  ImpulseWorkerListLength = 0;
}

Durations_of_Requests_and_OperationsPV0Impulse0::~Durations_of_Requests_and_OperationsPV0Impulse0() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double Durations_of_Requests_and_OperationsPV0Impulse0::Impulse_Function(double FiringTime)
{
return 1;

return(0);
}

ImpulseNodeClass** Durations_of_Requests_and_OperationsPV0Impulse0::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new Durations_of_Requests_and_OperationsPV0Impulse0;
  }

  return ImpulseWorkerList;
}

Durations_of_Requests_and_OperationsPV0::Durations_of_Requests_and_OperationsPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheClient_ServerRJ);
  double startpts[1]={0.0};
  double stoppts[1]={100};
  Initialize("Duration_of_Client_Request",(RewardType)1,1, startpts, stoppts, timeindex, 1,0, 0);
  AddImpulse("TI_Next_Operation","ClientSAN",&Impulse0);
}

Durations_of_Requests_and_OperationsPV0::~Durations_of_Requests_and_OperationsPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void Durations_of_Requests_and_OperationsPV0::CreateWorkerList(void) {
}
Durations_of_Requests_and_OperationsPV1Impulse0::Durations_of_Requests_and_OperationsPV1Impulse0()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&TransactionSAN_2);
  ImpulseWorkerListLength = 0;
}

Durations_of_Requests_and_OperationsPV1Impulse0::~Durations_of_Requests_and_OperationsPV1Impulse0() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double Durations_of_Requests_and_OperationsPV1Impulse0::Impulse_Function(double FiringTime)
{
return 1;

return(0);
}

ImpulseNodeClass** Durations_of_Requests_and_OperationsPV1Impulse0::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new Durations_of_Requests_and_OperationsPV1Impulse0;
  }

  return ImpulseWorkerList;
}

Durations_of_Requests_and_OperationsPV1::Durations_of_Requests_and_OperationsPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheClient_ServerRJ);
  double startpts[1]={0.0};
  double stoppts[1]={100};
  Initialize("Duration_of_Operation_Execution_Server_2",(RewardType)1,1, startpts, stoppts, timeindex, 1,0, 0);
  AddImpulse("TA_Execute_Operation","TransactionSAN_2",&Impulse0);
}

Durations_of_Requests_and_OperationsPV1::~Durations_of_Requests_and_OperationsPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void Durations_of_Requests_and_OperationsPV1::CreateWorkerList(void) {
}
Durations_of_Requests_and_OperationsPV2Impulse0::Durations_of_Requests_and_OperationsPV2Impulse0()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&TransactionSAN_1);
  ImpulseWorkerListLength = 0;
}

Durations_of_Requests_and_OperationsPV2Impulse0::~Durations_of_Requests_and_OperationsPV2Impulse0() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double Durations_of_Requests_and_OperationsPV2Impulse0::Impulse_Function(double FiringTime)
{
return 1;

return(0);
}

ImpulseNodeClass** Durations_of_Requests_and_OperationsPV2Impulse0::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new Durations_of_Requests_and_OperationsPV2Impulse0;
  }

  return ImpulseWorkerList;
}

Durations_of_Requests_and_OperationsPV2::Durations_of_Requests_and_OperationsPV2(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheClient_ServerRJ);
  double startpts[1]={0.0};
  double stoppts[1]={100};
  Initialize("Duration_of_Operation_Execution_Server_1",(RewardType)1,1, startpts, stoppts, timeindex, 1,0, 0);
  AddImpulse("TA_Execute_Operation","TransactionSAN_1",&Impulse0);
}

Durations_of_Requests_and_OperationsPV2::~Durations_of_Requests_and_OperationsPV2() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void Durations_of_Requests_and_OperationsPV2::CreateWorkerList(void) {
}
